﻿//=============================================================================
// RKRK.js	2016/07/30
// The MIT License (MIT)
//=============================================================================

/*:
 * @plugindesc 非汎用プラグイン
 * @author rekka rekka （劣化烈火）
 *
 * @help このプラグインにはプラグインコマンドはありません。
 */

(function(_global) {

Window_ActorCommand.prototype.makeCommandList = function() {
    if (this._actor) {
        this.addAttackCommand();
        this.addSkillCommands();
        //this.addGuardCommand();
        this.addItemCommand();
    }
};

Game_CharacterBase.prototype.moveStraight = function(d) {
    this.setMovementSuccess(this.canPass(this._x, this._y, d));
    if (this.isMovementSucceeded()) {
        this.setDirection(d);
        this._x = $gameMap.roundXWithDirection(this._x, d);
        this._y = $gameMap.roundYWithDirection(this._y, d);
        this._realX = $gameMap.xWithDirection(this._x, this.reverseDir(d));
        this._realY = $gameMap.yWithDirection(this._y, this.reverseDir(d));
        this.increaseSteps();

		//

    } else {
        this.setDirection(d);
        this.checkEventTriggerTouchFront(d);
    }
};

Game_Party.prototype.increaseSteps = function() {
//	console.log($gameActors);
	$gameActors._data.forEach(function(value,index)
	{
		if(index != 0)
		{
			if(value._mp>0)
			{
				if(value._hp < value.mhp)
				{
					value._hp++;
				}
			}
			if($gameParty._steps %20 == 0 && $gameParty._steps != 0)
			{
				if(value._mp>0)
				{
					value._mp--;
				}
				else
				{
					value._hp--;
				}
			}
		}
	});
    this._steps++;
};



Game_Actor.prototype.displayLevelUp = function(newSkills) {
    var text = TextManager.levelUp.format(this._name, TextManager.level, this._level);
    $gameMessage.newPage();
    $gameMessage.add(text);
	console.log(newSkills);//rkrk
    newSkills.forEach(function(skill) {
        $gameMessage.add(TextManager.obtainSkill.format(skill.name));
    });
};


Game_Actor.prototype.findNewSkills = function(lastSkills) {
	console.log('-------------------findNewSkills----------------');
	console.log(lastSkills);

    var newSkills = this.skills();

	console.log(newSkills);

    for (var i = 0; i < lastSkills.length; i++) {
        var index = newSkills.indexOf(lastSkills[i]);
        if (index >= 0) {
            newSkills.splice(index, 1);
        }
    }
    return newSkills;
};


Yanfly.EBS.Game_Actor_skills = Game_Actor.prototype.skills;
Game_Actor.prototype.skills = function() {
	console.log('--------------game_actor.skills----------------');
	console.log(this.isGetBattleSkills());
    if (this.isGetBattleSkills()) {
      return this.battleSkills();
    } else {
      return Yanfly.EBS.Game_Actor_skills.call(this);
    }
};

Game_Actor.prototype.skills = function() {
    var list = [];


    this._skills.concat(this.addedSkills()).forEach(function(id) {
        if (!list.contains($dataSkills[id])) {
            list.push($dataSkills[id]);
        }
    });
    return list;
};

})(this);
